#include "nohtml.h"

#include <library/cpp/testing/unittest/registar.h>

#include <util/memory/tempbuf.h>
#include <util/charset/wide.h>

Y_UNIT_TEST_SUITE(TestNoHtml) {
    Y_UNIT_TEST(Test) {
        TStringBuf dirty("&quot;AINA&quot; &quot;АЙНА&quot; &lt;a href=\"#\"&gt;robots.txt&lt;/a&gt;. &lt;a href=\"#\"&gt;Подробнее...&lt;/a&gt; PCI\\VEN_197B&amp;DEV_2382&amp;SUBSYS_74651558&amp;REV_80 &amp;quot;&lt;b&gt;Интернет-магазин&lt;/b&gt;&amp;quot;, <a href=\"https://www.someurl.ru\">Детские коляски</a>, &amp;Коляски&amp;-трансформеры, &amp;&quot;Otutto 3&amp;&quot; (PRAM), Inglesina. <P>Система <B>OTUTTO</B> - все, что вам нужно!</P><P><STRONG>В комплекте: </STRONG>Люлька, прогулочная коляска, автокресло с базой, накидка на ножки, капюшон, сумка, корзина для покупок</P><P><B>Люлька:</B></P><LI><UL type=circle><LI>Внутренняя обивка выполнена из хлопка. <LI>Размеры спального места: длина см х ширина см х глубина см. <LI>Система EASY CLIP. </LI></UL><BR><B>Прогулочное сидение:</B> <LI><UL type=circle><LI>5 точечные ремни безопасности. <LI>Обшивка коляски легко снимается. Стирается при температуре 30 градусов. <LI>Сетка для продуктов. <LI>Утепленный мешок для ножек. <LI>Регулируемая спинка и подножка. </LI></UL><BR><B>Inglesina Haggy + база Автокресло-переноска от 0 до 13 кг</B><BR><UL type=circle><LI>Автомобильное кресло относится к группе 0-0+, подходит детям > 0 до 1 года или < 13 кг. <LI>Соответствует европейскому стандарту безопасности ECE R44/03 (0+/1 Группе). <LI>Может быть установлено на шасси Inglesina. <LI>Имеет защитный капюшон от солнца, вставку для новорожденного ребенка для поддержки головы. <LI>Сидение необыкновенно <b>комфортное</b> благодаря <strong>мягкой</strong> набивке и <b>использования <b>специальных</b> хлопчатобумажных</b> материалов. <LI>Съемное покрытие можно стирать при &температуре& не выше 30 градусов. </LI></UL><LI><B>Ручка:</B> <UL type=circle><LI>Удобная эргономическая ручка. </LI></UL><LI><B>Колеса:</B> <UL type=circle><LI>4 пары сдвоенных колес, <плавающие> с фиксацией. <LI>колеса с тормозом. <LI>Размер: 18,5 см </LI></UL><LI><B>Шасси:</B> <UL type=circle><LI>Алюминиевое. <LI>Размер коляски в сложенном виде: ширина 39 см длина 36 х высота 100 см. <LI>Размер коляски в разложенном виде: ширина 59.9 см х длина 92 см х высота 110 см. <LI>Вес: 7,4 кг</LI></UL></LI> <snippet>4.18 &lt;b&gt;Примером&lt;/b&gt; &lt;b&gt;влияния&lt;/b&gt; природных факторов &lt;b&gt;на&lt;/b&gt; &lt;b&gt;развитие&lt;/b&gt; &lt;b&gt;общества&lt;/b&gt; &lt;b&gt;является&lt;/b&gt;. &lt;br/&gt;… 4.19 В отличие от &lt;b&gt;природы&lt;/b&gt;, &lt;b&gt;общество&lt;/b&gt;. &lt;b&gt;является&lt;/b&gt; системой находится в &lt;b&gt;развитии&lt;/b&gt; выступает в качестве творца культуры &lt;b&gt;развивается&lt;/b&gt; по собственным законам.</snippet> <snippet>&lt;b&gt;Размер&lt;/b&gt; универсальный. сделано в Тайланде. отличное соотношение цена/качество. крепление- двойная застежка на задней части &lt;b&gt;шлема&lt;/b&gt;. полная защита головы, скул, ушей и подбородка. &lt;br/&gt;… Нет в наличии. &lt;b&gt;Параметры&lt;/b&gt; категории: -- &lt;b&gt;Шлемы&lt;/b&gt;.</snippet> ООО&quot;АЙНА&quot; &lt;b&gt;ООО&lt;/b&gt; &amp;quot;&lt;b&gt;АЙНА&lt;/b&gt;&amp;quot;, г. &amp;Череповец&amp; - контакты, телефоны <snippet>Организационно-правовая форма: &lt;b&gt;Общества&lt;/b&gt; &lt;b&gt;с&lt;/b&gt; &lt;b&gt;ограниченной&lt;/b&gt; &lt;b&gt;ответственностью&lt;/b&gt;. &lt;br/&gt;… &lt;b&gt;ООО&lt;/b&gt; &amp;quot;&lt;b&gt;АЙНА&lt;/b&gt;&amp;quot; находится в категориях</snippet> <snippet>Описание веб-страницы недоступно из-за ограничений в файле &lt;a href=\"#\"&gt;robots.txt&lt;/a&gt;. &lt;a href=\"#\"&gt;Подробнее...&lt;/a&gt;</snippet>");
        TStringBuf clear("\"AINA\" \"АЙНА\" robots.txt. Подробнее... PCI\\VEN_197B&DEV_2382&SUBSYS_74651558&REV_80 \"Интернет-магазин\", Детские коляски, &Коляски&-трансформеры, &\"Otutto 3&\" (PRAM), Inglesina. Система OTUTTO - все, что вам нужно!В комплекте: Люлька, прогулочная коляска, автокресло с базой, накидка на ножки, капюшон, сумка, корзина для покупокЛюлька:Внутренняя обивка выполнена из хлопка. Размеры спального места: длина см х ширина см х глубина см. Система EASY CLIP. Прогулочное сидение: 5 точечные ремни безопасности. Обшивка коляски легко снимается. Стирается при температуре 30 градусов. Сетка для продуктов. Утепленный мешок для ножек. Регулируемая спинка и подножка. Inglesina Haggy + база Автокресло-переноска от 0 до 13 кгАвтомобильное кресло относится к группе 0-0+, подходит детям > 0 до 1 года или < 13 кг. Соответствует европейскому стандарту безопасности ECE R44/03 (0+/1 Группе). Может быть установлено на шасси Inglesina. Имеет защитный капюшон от солнца, вставку для новорожденного ребенка для поддержки головы. Сидение необыкновенно комфортное благодаря мягкой набивке и использования специальных хлопчатобумажных материалов. Съемное покрытие можно стирать при &температуре& не выше 30 градусов. Ручка: Удобная эргономическая ручка. Колеса: 4 пары сдвоенных колес, <плавающие> с фиксацией. колеса с тормозом. Размер: 18,5 см Шасси: Алюминиевое. Размер коляски в сложенном виде: ширина 39 см длина 36 х высота 100 см. Размер коляски в разложенном виде: ширина 59.9 см х длина 92 см х высота 110 см. Вес: 7,4 кг 4.18 Примером влияния природных факторов на развитие общества является. … 4.19 В отличие от природы, общество. является системой находится в развитии выступает в качестве творца культуры развивается по собственным законам. Размер универсальный. сделано в Тайланде. отличное соотношение цена/качество. крепление- двойная застежка на задней части шлема. полная защита головы, скул, ушей и подбородка. … Нет в наличии. Параметры категории: -- Шлемы. ООО\"АЙНА\" ООО \"АЙНА\", г. &Череповец& - контакты, телефоны Организационно-правовая форма: Общества с ограниченной ответственностью. … ООО \"АЙНА\" находится в категориях Описание веб-страницы недоступно из-за ограничений в файле robots.txt. Подробнее...");
        TString res = NoHtml(dirty);
        UNIT_ASSERT_EQUAL(clear, res);
    }
}
